import requests
import random

server_url="https://codeguessing.gay/extra/game70"

def get_grid(s):
    r = s.get(server_url)
    return r.json()["grid"]

def get_move(cp, tp, bp):
    (cx, cy)=cp
    (tx, ty)=tp
    dx = [-1, 1][cx < tx]
    dy = [-1, 1][cy < ty]
    if cx != tx and bp != (cx + dx, cy) and cy != ty and bp != (cx, cy + dy):
        return random.choice([cx < tx, 2 + (cy < ty)])

    if cx != tx and bp != (cx + dx, cy):
        return cx < tx
    if cy != ty:
        if bp != (cx, cy + dy):
            return 2 + (cy < ty)
        return random.randrange(0, 2)
    return random.randrange(2, 4)

def get_pos(thing, grid):
    idx = grid.find(thing)
    return (idx % 16, idx // 16)

def get_positions(grid):
    cp = get_pos("@", grid)
    tp = get_pos("+", grid)
    bp = get_pos("*", grid)
    return (cp, tp, bp)

def make_move_local(cp, move):
    (dx, dy) = [(-1, 0), (1, 0), (0, -1), (0, 1)][move]
    return (cp[0]+dx, cp[1]+dy)

def make_move_remote(s, move):
    move=["left", "right", "up", "down"][move]
    r = s.post(server_url, headers={"Content-Type": "application/json"}, json={"dir": move})
    return r.json()["grid"]

def make_move(s, grid):
    (cp, tp, bp) = get_positions(grid)
    while cp != tp:
        move = get_move(cp, tp, bp)
        cp = make_move_local(cp, move)
        make_move_remote(s, move)


def main():
    with requests.Session() as s:
        s.cookies = requests.utils.add_dict_to_cookiejar(s.cookies, {"session": ""})

        while True:
            grid=get_grid(s)
            print(grid)
            make_move(s, grid)

main()
